AchievementTheWhiteKnight = class(Turbine.UI.Control)
function AchievementTheWhiteKnight:Constructor(handler)
    Turbine.UI.Control.Constructor(self)

    self.equipment = Turbine.Gameplay.LocalPlayer.GetInstance():GetEquipment()
    self.timer = 0
    self.itemIndex = 0
    self.itemEquippedCallback = AddCallback(self.equipment, "ItemEquipped", function(sender, args)
        local item = self.equipment:GetItem(args.Index)
        if item ~= nil then 
            local itemInfo = item:GetItemInfo()
            if itemInfo:GetQuality() ~= 5 then
                if not( self.updateCallback) then
                    self.itemIndex = args.Index
                    self.timer = 10
                    self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate)
                    ChatOutput("<rgb=#FF0000>Unequip your item within 10 seconds or you will fail the achievement!")
                end
            end
        end	
    end)

    self.itemUnEquippedCallback= AddCallback(self.equipment, "ItemUnequipped", function(sender, args)
        if self.updateCallback and self.itemIndex == args.Index then
            ChatOutput("<rgb=#00FF00>Item successfully unequipped.")
            RemoveCallback(Updater, "ExecuteUpdate",  self.updateCallback)
            self.updateCallback = nil
        end
    end)

    self.ExecuteUpdate = function(delta)
        self.timer = self.timer - delta
        if self.timer < 0 then
            handler:Fail("The White Knight", "Equipped a wrong item", 0x410081B3)
            if self.updateCallback then
                RemoveCallback(Updater, "ExecuteUpdate",  self.updateCallback)
                self.updateCallback = nil
            end
        end

    end

end

function AchievementTheWhiteKnight:Unload()
    if self.updateCallback then
        RemoveCallback(Updater, "ExecuteUpdate",  self.updateCallback)
        self.updateCallback = nil
    end
    RemoveCallback(self.equipment, "ItemEquipped", self.itemEquippedCallback)
    RemoveCallback(self.equipment, "ItemUnequipped", self.itemUnEquippedCallback)
end